/*
 * Fachlicher Schlüssel für JPA Entität
 */
package de.ivu.elect.business.wahlvorschlag.entity;

import de.ivu.elect.jee.faces.Messages;
import de.ivu.elect.jee.faces.IMessages;
import java.util.function.Function;

@javax.enterprise.inject.Vetoed
public class WahlvorschlagTK
implements de.ivu.elect.jee.entity.tk.EntityTK, java.io.Serializable
  {

  private static final long serialVersionUID = 1L;

  private final int hashCode;

    protected final java.lang.String discriminator;
    public java.lang.String getDiscriminator(){
      return discriminator;
    }
  protected final de.ivu.elect.business.gruppeimgebiet.entity.GruppeImGebietTK gruppeImGebietTK;
    public de.ivu.elect.business.gruppeimgebiet.entity.GruppeImGebietTK getGruppeImGebietTK(){
      return gruppeImGebietTK;
    }

  public WahlvorschlagTK(
java.lang.String discriminator
,   de.ivu.elect.business.gruppeimgebiet.entity.GruppeImGebietTK gruppeImGebietTK
  ) {
    super();


      this.discriminator = discriminator;
        this.gruppeImGebietTK = gruppeImGebietTK;
  
hashCode = calculateHashCode();
  }

  @Override
  public int hashCode(){
    return hashCode;
  }


  protected int calculateHashCode() {
        int result = 1;
    
    
                    result = result + ((discriminator == null) ? 0 : discriminator.hashCode());
        
                    result = result + ((gruppeImGebietTK == null) ? 0 : gruppeImGebietTK.hashCode());
            
    return result;
  }

  @Override
  public boolean equals(Object obj) {
    if (this == obj) {
      return true;
    }

    if (obj == null) {
      return false;
    }

    if (hashCode()!=obj.hashCode()) {
      return false;
    }


            
    if (getClass() != obj.getClass()) {
      if (!(obj instanceof WahlvorschlagTK)) {
        return false;
      }

      if (!obj.getClass().isInstance(this)) {
        return obj.equals(this); // equals-Methode aus speziellerer Klasse verwenden
      }

    }

        WahlvorschlagTK other = (WahlvorschlagTK) obj;

                if (discriminator == null) {
          if (other.discriminator != null) {
            return false;
          }
        } else if (!discriminator.equals(other.discriminator)) {
          return false;
        }
        
                if (gruppeImGebietTK == null) {
          if (other.gruppeImGebietTK != null) {
            return false;
          }
        } else if (!gruppeImGebietTK.equals(other.gruppeImGebietTK)) {
          return false;
        }
            return true;
    
  }

  protected boolean hatAttribute() {
        return true;
      }

  @Override
  public String getEntityMessageKey() {
    return WahlvorschlagConstants.MESSAGE_KEY_ENTITY_EINZAHL;
  }

  @Override
  public java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> getAllEntityFieldValues() {
    java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> result = new java.util.ArrayList<>();

    result.addAll(getEntityFieldValuesForEntity());
    result.addAll(gruppeImGebietTK.getAllEntityFieldValues());
    return result;
  }

  @Override
  public java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> getEntityFieldValuesForEntity() {
            java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> result = new java.util.ArrayList<>();

                    result.add(new de.ivu.elect.jee.entity.tk.EntityFieldValue(WahlvorschlagConstants.MESSAGE_KEY_ENTITY_EINZAHL, WahlvorschlagConstants.MESSAGE_KEY_DISCRIMINATOR_EINZAHL, discriminator));
        
        return result;
      }


            @Override
            public String toString() {
            return "WahlvorschlagTK[" + toStringParameter() + "]";
            }



            protected String toStringParameter() {
            String result = ""

                                        +"discriminator="+discriminator
                                        +", gruppeImGebietTK="+gruppeImGebietTK
            
            ;
                            return result;
            
            }

  @Override
  public String toStringLokalisiert(IMessages messages) {
    return messages.getMessageForMessageKey(getEntityMessageKey()) + " ["
            + toStringLokalisiertFields(messages)
            + "]"
            ;
   }

            protected String toStringLokalisiertFields(IMessages messages) {
        return ""
                                      + messages.getMessageForMessageKey(WahlvorschlagConstants.MESSAGE_KEY_DISCRIMINATOR_EINZAHL) + "=" +

                                    discriminator
                
                                      + ", " +  toStringLokalisiert(gruppeImGebietTK, messages)
                                 ;
      }


            private String toStringLokalisiert(de.ivu.elect.jee.entity.tk.EntityTK entityTK, IMessages messages) {
                if (entityTK != null) {
                    return entityTK.toStringLokalisiert(messages);
                }
                return null;
            }

            public static <E extends Wahlvorschlag> java.util.Map<WahlvorschlagTK, E> mappeWahlvorschlagNachTK(java.util.Collection<E> entities) {
                return entities.stream().collect(java.util.stream.Collectors.toMap(Wahlvorschlag::getWahlvorschlagTK, Function.<E>identity(), (u,v)-> v));
                }


                public static Function<Wahlvorschlag, WahlvorschlagTK> getWahlvorschlagToTKFunction() {
                return Wahlvorschlag::getWahlvorschlagTK;
                }

}
